                        
#include <X11/Xlib.h>
#include <X11/Xutil.h>		/* for XLookupString */
#include<sys/time.h>  
#include<stdio.h>
 
#include<stdlib.h>
#include<unistd.h>
#include<fcntl.h>
#include<sys/types.h>
#include<sys/ioctl.h>
#include<linux/soundcard.h>
#include<linux/cdrom.h>

#include "inc/UnitR.cpp"
#include "inc/UnitG.cpp"

//#include  "TESSND.H"

 
static Display *display;
static Window rootwin;
static int screen;
static Window window;
static  GC gc;
static  U_8bit MouseButton=0;
Visual *visual;
int testi;
U_16bit msx,msy;
XImage  *ximg;
int FormLeft=30,FormTop=20;

  int MusicLoop;
  int fd_sound=-1; /* Sound Dev ID*/
  int stat=-1;
  struct cdrom_ti  ti;
  struct cdrom_subchnl subchnl;
  struct cdrom_volctrl cdvol;

#define CANVAS_WIDTH	640
#define CANVAS_HEIGHT	352
static char canvas[CANVAS_HEIGHT*CANVAS_WIDTH*4];
static char VRAM[CANVAS_WIDTH*CANVAS_HEIGHT*4];
void  timer( int );     /* ^C}[̊֐̐錾 */

void  al_Bloak_Load(U_16bit BlockNo,U_8bit* adr){
char fname[128];
FILE *fp;
    
     sprintf(fname,"Block/Div%d/Block%d.dat",(BlockNo>>4),BlockNo);
     //sprintf(fname,"Block%d.dat",BlockNo);
    printf(fname);printf("\n");
   if ((fp = fopen(fname,"rb"))== 0) {
      printf("\n**BlockReadErr**\n");
   } else {
      fread(adr,1,1024*(1024+256),fp);
      fclose(fp);
      
   }
  printf("\nFileP %d\n",fp);


}
void  al_CD_PLAY(U_8bit TrackN){  // CDĐ
  ti.cdti_trk0=TrackN;
  ti.cdti_trk1=TrackN;
  MusicLoop=-1;
}
void  al_CD_PLAY_LOOP(U_8bit TrackN){ MusicLoop=1; // CDĐiJԂj
  ti.cdti_trk0=TrackN;
  ti.cdti_trk1=TrackN;
  MusicLoop=-99999;
  
}

char USERINIFILENAME[]="userdata.ico";
//--------------------------------------------------------------------------- ݒt@Cǂݍ
bool16  al_INI_Load(U_8bit* adr,U_16bit size){
  FILE *fp;

   if ((fp = fopen(USERINIFILENAME,"r+b"))== 0) {
      return(0);
   } else {
      fread(adr,1,4608,fp);
      fclose(fp);
      return(1);
   }
}
//--------------------------------------------------------------------------- ݒt@Cۑ
void  al_INI_Save(U_8bit* adr,U_16bit size){
  FILE *fp;
   if ((fp = fopen(USERINIFILENAME,"w+b"))== 0) {
      printf("FileSaveErr");
   } else {
      printf("Ini Data Save");
      fwrite(adr,1,4608,fp);
      printf("Ini Data Save OK.");
      fclose(fp);
      return;
   }
}



int main(int argc, char **argv)
{
  char *display_name = ":0";
  int quit = 0;
  int plot_mode = 0;		/* 0:white 1:black */
  XEvent event;
  char buf[10];
  int depth;
  U_8bit *sp,*dp8;
  U_16bit *dp;
  U_8bit rr,gg,bb;
  U_16bit cc;
  U_8bit rshift,gshift,bshift;
  int mx, my;
  int rootx, rooty;
  unsigned int kb;
  Window root, child;

  int cd_cnt=0;  //XCD`FbN
  int BitPerPixel;



 struct timeval  MMSEC; /* L\ */
  
  
  ti.cdti_trk0=1;
  ti.cdti_ind0=0;
  ti.cdti_trk1=1;
  ti.cdti_ind1=0;
  MusicLoop=99999;

  cdvol.channel0=15;
  cdvol.channel1=15;

  fd_sound = open("/dev/cdrom",O_RDONLY);
  printf("CD-ROM OPEN stat=%d",fd_sound);
  



  testi=0;
   MouseButton=0;
   AliaLive_Init(VRAM,1);
  
  if (argc == 3 && strcmp(argv[1], "-display") == 0) {
    display_name = argv[2];
  }
  display = XOpenDisplay(display_name);
  rootwin = DefaultRootWindow(display);
  screen = DefaultScreen(display);
  depth = DefaultDepth(display,0);
 visual  = DefaultVisual(display,0);
   printf("depth = %d\n",depth);

  window = XCreateSimpleWindow(display, DefaultRootWindow(display),
			       FormLeft, FormTop, CANVAS_WIDTH, CANVAS_HEIGHT, 2,
			       BlackPixel(display, screen),
			       WhitePixel(display, screen));
  XSelectInput(display, window,
	       ExposureMask|ButtonPressMask|KeyPressMask);
  XStoreName(display, window, "AliaLive");
  XMapRaised(display, window);
  gc = XCreateGC(display, window, 0, NULL);
  XSetForeground(display, gc, BlackPixel(display, screen));

   
 //depth=32;

 //if(depth==24) ximg = XCreateImage(display, visual,  depth ,  ZPixmap,0, (char*)VRAM,     640,352,32,0);
 //if(depth==16) ximg = XCreateImage(display, visual,  depth ,  ZPixmap,0, (char*)canvas,   640,352,32,0);
 //if(depth==32) ximg = XCreateImage(display, visual,   24   ,  ZPixmap,0, (char*)canvas,   640,352,32,0);
 
 ximg = XCreateImage(display, visual,  depth ,  ZPixmap,0, (char*)canvas,   640,352,32,0);

 BitPerPixel=depth;

        rshift=gshift=bshift=0;
        for(i=0;i<16;i++){
              if( (16<<rshift)<ximg->red_mask ) rshift++;
              if( (16<<gshift)<ximg->green_mask ) gshift++;
              if( (16<<bshift)<ximg->blue_mask ) bshift++;
        }
        printf("r shift %d\n",--rshift);
        printf("g shift %d\n",--gshift);
        printf("b shift %d\n",--bshift);
    
        printf("r mask%x\n",ximg->red_mask);
        printf("g mask%x\n",ximg->green_mask);
        printf("b mask%x\n",ximg->blue_mask);
        printf("byte/line  %x\n",ximg->bytes_per_line);
        printf("bit/pointData  %d\n",ximg->bitmap_unit);
        printf("bit/pixel  %d\n",ximg->bits_per_pixel);
        printf("xoffset  %d\n",ximg->xoffset);
        
        if(ximg->bytes_per_line==640*4)BitPerPixel=32;

  while (!quit) {
	    if( XEventsQueued( display, QueuedAfterFlush ) == 0 )  /* CxgȂ */
	      {  
  
			 gettimeofday( &MMSEC, NULL );    /* 𒲂ׂVXeR[ */


                   XQueryPointer(display, window, &root, &child, &rootx, &rooty, &mx, &my, &kb);
                   //msx=mx; msy=my;
                   msx=mx; msy=my;

                       // printf("time %d\n",(U_32bit)(MMSEC.tv_usec/1000));
		       AliaLive_Exec((S_16bit)msx,(S_16bit)msy,(U_8bit*)&MouseButton, (U_32bit)(MMSEC.tv_sec*1000+MMSEC.tv_usec/1000)  ) ;
		 //      AliaLive_Exec((S_16bit)0,(S_16bit)0,(U_8bit*)&MouseButton, MMSEC.tv_usec/1000  ) ;
 
  if((MusicLoop<0)&&(fd_sound!=-1)){
     stat = ioctl(fd_sound,CDROMSTOP);
     printf("CD-ROM STOP = %d\n",stat);
     MusicLoop=-MusicLoop;
     cd_cnt=31;
  }

  cd_cnt++;                       
  if( ((cd_cnt&31)==0)&&(MusicLoop)&&(fd_sound!=-1) ){
     subchnl.cdsc_format=CDROM_MSF;
     stat=ioctl(fd_sound,CDROMSUBCHNL,&subchnl);
     printf("cdstat %d\n",subchnl.cdsc_audiostatus);
     if(subchnl.cdsc_audiostatus!=CDROM_AUDIO_PLAY){
       stat = ioctl(fd_sound,CDROMSTOP);
       printf("CD-ROM STOP = %d\n",stat);
       stat = ioctl(fd_sound,CDROMPLAYTRKIND,&ti);
       printf("CD ROM PLAY TRACK =%d\n",stat);
       stat = ioctl(fd_sound,CDROMVOLCTRL,&cdvol);
       printf("CD-ROM VOL stat=%d\n",stat);
       MusicLoop--;
     }
  }


			        if(BitPerPixel==16){
			                sp=(U_8bit*)VRAM;
			                dp=(U_16bit*)canvas;
			
			                for(i=0;i<352;i++){
			                    for(j=0;j<640;j++){
					                 bb=(*sp++)>>3;
					                 gg=(*sp++)>>3;
					                 rr=(*sp++)>>3;
							 cc=((rr<<rshift)|(gg<<gshift)|(bb<<bshift));
							*dp++=cc; //*dp++=(cc>>8);
					                //*dp++=(cc&0xff);
			                     }
			                }
			         }
			        if(BitPerPixel==24){
			                sp=(U_8bit*)VRAM;
			                dp8=(U_8bit*)canvas;
			
			                for(i=0;i<352;i++){
			                    for(j=0;j<640;j++){
							 *dp8++=*sp++;
							 *dp8++=*sp++;
							 *dp8++=*sp++;
			                     }
			                }
			         }
			        if(BitPerPixel==32){
			                sp=(U_8bit*)VRAM;
			                dp8=(U_8bit*)canvas;
			
			                for(i=0;i<352;i++){
			                    for(j=0;j<640;j++){
							 *dp8++=*sp++;
							 *dp8++=*sp++;
							 *dp8++=*sp++;
					                 *dp8++=0;
			                     }
			                }
			         }

		      XPutImage(display, window, gc, ximg, 0, 0, 0, 0, 640, 352);
    	            //timer( 20 * 1000 );
    	            //sleep( 20 );
	      }  
	    else  /* Cxĝŏ */
	     {
		    XNextEvent(display, &event);
		    switch (event.type) {
		    case Expose:
		        ;
		     // redraw(event.xexpose.x, event.xexpose.y,
			//     event.xexpose.width, event.xexpose.height);
		      break;
		    case ButtonPress:
                    
                      msx=event.xbutton.x;
                      msy=event.xbutton.y;
 
                        // printf("mb x:%d  y:%d",msx,msy);
                MouseButton|=2;
		      break;
		    case MappingNotify:
		      XRefreshKeyboardMapping(&event.xmapping);
		      break;
		    case KeyPress:
		      if (XLookupString(&event.xkey, buf, sizeof(buf), NULL, NULL)) {
			quit = ((buf[0] == 'q')||(buf[0] == 27));
			if (buf[0] =='t') MouseButton|=0x80;
		      }
		      break;
		    }
		 }
  }
  stat = ioctl(fd_sound,CDROMSTOP);
  printf("sound bit stat=%d\n",stat);
  stat = ioctl(fd_sound,CDROMRESET);
  printf("sound bit stat=%d\n",stat);
  close(fd_sound);
  XFreeGC(display, gc);
  XDestroyWindow(display, window);
  XCloseDisplay(display);
  return 0;
}


void timer( int interval )
{
 struct timeval  old_time, new_time; /* L\ */

 gettimeofday( &old_time, NULL );    /* 𒲂ׂVXeR[ */
 while( True )
   {
    gettimeofday( &new_time, NULL ); /* 𒲂ׂVXeR[ */
    if( new_time.tv_sec > old_time.tv_sec )
       new_time.tv_usec += 1000000;
    if( new_time.tv_usec - old_time.tv_usec > interval )
       return ;  /* w肳ꂽԂ߂Ă߂ */
   }
}
/* End of file */
